<template>
  <div id="app">
    <!-- Always shows a header, even in smaller screens. -->
    <div class="mdl-layout mdl-js-layout mdl-layout--fixed-header">
      <header class="mdl-layout__header">
        <div class="mdl-layout__header-row">
          <!-- Title -->
          <span class="mdl-layout-title">Title</span>
          <!-- Add spacer, to align navigation to the right -->
          <div class="mdl-layout-spacer"></div>
          <!-- Navigation. We hide it in small screens. -->
          <nav class="mdl-navigation mdl-layout--large-screen-only">
            <button
              @click="ProcessImage" 
              class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--accent">
              Process images
            </button>
            <button 
              @click="$store.commit('startDialog', getImageLoadDialogELement())"
              class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect mdl-button--accent">
              Upload image
            </button>
          </nav>
        </div>
      </header>
      <snackbar/>
			<image-upload-dialog/>
      <main class="mdl-layout__content">
        <div class="page-content">
          <div 
            v-for="(image, index) in $store.state.imageList"
            :key="index">
            <imageCard :url="image" :index="index"/>
          </div>
        </div>
      </main>
    </div>
  </div>
</template>

<script>
import ImageUploadDialog from './components/ImageUploadDialog';
import Snackbar from './components/Snackbar';
import ImageCard from './components/ImageCard';

export default {
	name: 'App',
	components: {
		ImageUploadDialog,
		Snackbar,
		ImageCard,
	},
	methods: {
		getImageLoadDialogELement() {
			return document.querySelector('#image-load-dialog');
		},
		ProcessImage() {
			let self = this;
			this.$store
				.dispatch('ProcessImage')
				.then(function(res) {
					self.$store.commit(
						'showSnackbar',
						'Process image compleated success'
					);
				})
				.catch(function(err) {
					self.$store.commit(
						'showSnackbar',
						'An error handle wile process image'
					);
				});
		},
		getFileExtension(file_name) {
			return file_name
				.split('.')
				.pop()
				.toLowerCase();
		},
	},
};
</script>

<style>
@import url('https://fonts.googleapis.com/css?family=Roboto');
@import url('https://code.getmdl.io/1.3.0/material.blue_grey-orange.min.css');
@import url('https://fonts.googleapis.com/icon?family=Material+Icons');

#app {
	font-family: 'Roboto', sans-serif;
	-webkit-font-smoothing: antialiased;
	-moz-osx-font-smoothing: grayscale;
}
nav.mdl-navigation.mdl-layout--large-screen-only > button {
	margin-right: 1em;
}
nav.mdl-navigation.mdl-layout--large-screen-only > button:last-child {
	margin-right: 0em;
}
.page-content {
	display: flex;
	margin: 2em;
}
.page-content > div {
	margin-right: 1em;
}
.page-content > div:last-child {
	margin-right: 0em;
}
</style>
